<template>
    <div id="roundSummary" class="container text-center">
        <h2>Round Summary</h2>
        <table class="text-center center">
            <tr>
                <td>
                    <StorytellerCardDisplay></StorytellerCardDisplay>
                </td>
                <td>
                    <PlayerPoints></PlayerPoints>
                </td>
            </tr>
        </table>
    </div>
</template>
<script>
    import PlayerPoints from './PlayerPoints.vue';
    import StorytellerCardDisplay from './StorytellerCardDisplay.vue';
    import axios from 'axios';
    export default {
        name: 'roundSummary',
        components: {
            PlayerPoints,
            StorytellerCardDisplay
        },
        data: function () {
            return {
                isGameOver: false,
                gameId: this.$route.params.gameId,
                playerId: this.$route.params.playerId,
                newRoundId: 0,
                isStoryteller: false,
                myParams: null
            }
        },
        methods: {
            checkIfGameIsOver() {
                axios.get("https://localhost:44361/api/game/" + this.gameId + "/isGameOver")
                    .then(response => this.isGameOver = response.data);
            },
            redirectNewStoryteller(myParams) {
                this.$router.push({
                    name: 'storytellerPage',
                    params: myParams
                });
            },
            redirectPlayer(myParams) {
                this.$router.push({
                    name: 'playerPage',
                    params: myParams
                });
            },
            redirect(isstoryteller) {
                var myParams = {
                    playerId: this.playerId,
                    gameId: this.gameId,
                    roundId: this.newRoundId
                }
                if (isstoryteller) {
                    this.redirectNewStoryteller(myParams);
                }
                else {
                    this.redirectPlayer(myParams);
                }
            },
            createNewRound() {
                return axios.get("https://localhost:44361/api/game/" + this.gameId + "/player/" + this.playerId + "/newRound");
            },
            isNewStoryteller(newRoundId) {
                this.newRoundId = newRoundId;
                return axios.get("https://localhost:44361/api/round/" + newRoundId + "/player/" + this.playerId + "/isStoryteller");
            },
            assignMissingCards() {
                axios.get("https://localhost:44361/api/game/" + this.gameId + "/player/" + this.playerId + "/missingCard")
            },
            redirectAfterRoundSummary() {
                if (this.isGameOver) {
                    this.$router.push({ name: 'endOfGame', params: { gameId: this.gameId } });
                }
                else {
                this.assignMissingCards();
                this.createNewRound().then(newroundId => this.isNewStoryteller(newroundId.data)
                .then(response => this.redirect(response.data)));
                }
            }
        },
        created: function () {
            this.checkIfGameIsOver();
            setTimeout(
                () =>
                    this.redirectAfterRoundSummary(), 5000);
        },
    }
</script>

<style scoped>
    .card {
        height: 250px;
        display: flex;
    }
    .center {
        margin-left: auto;
        margin-right: auto;
    }
     td {
        padding: 20px;
    }
</style>

